#include "7seg.h"

/*

0   rxd    rxd
1   txd    -t-x-d-  A   (serial will not work)

2   pd2    B
3   pd3    C
4   pd4    D
5   pd5    E
6   pd6    F
7   pd7    G
                220 R
8   pb0    0  --/\/\/\--
9   pb1    1  --/\/\/\--
10  pb2    2  --/\/\/\--
11  pb4    3  --/\/\/\--
12  pb3    4  --/\/\/\--
13  pb5    5  --/\/\/\--


A0  pc0    6  --/\/\/\--
A1  pc1    7  --/\/\/\--
A2  pc2    8  --/\/\/\--
A3  pc3    9  --/\/\/\--
A4  pc4    10 --/\/\/\--
A5  pc5    11 --/\/\/\--


A6  adc6
A7  adc7

*/

// use : for space!
uint8_t message[] = "::::::867:5309::JENNY:::::::867:5309:::::::::::::";
#define msglen 46



void clear(void);


    
void setup() {
    // set up directions 
    
  DDRB = (OUTPUT << PB0 | OUTPUT << PB1 |OUTPUT << PB2 |OUTPUT << PB3 |OUTPUT << PB4 |OUTPUT << PB5 |INPUT << PB6 |INPUT << PB7);
  DDRC = (OUTPUT << PC0 | OUTPUT << PC1 |OUTPUT << PC2 |OUTPUT << PC3 |OUTPUT << PC4 |OUTPUT << PC5 | INPUT << PC6 );
  DDRD = (INPUT << PD0 | OUTPUT << PD1 |OUTPUT << PD2 |OUTPUT << PD3 |OUTPUT << PD4 |OUTPUT << PD5 |OUTPUT << PD6 |OUTPUT << PD7);              

 
}

void loop() {

  static uint8_t offset = 0;
  static uint8_t DD[12] = {':', ':', ':', ':', ':', ':', ':', ':', ':', ':', ':', ':'};
  static unsigned int i = 1;
  static uint8_t segMask = 0x01;
  
  // put your main code here, to run repeatedly:
 
    clear();
    PORTD = segMask << 1; // activate the next segment to be displayed.
    // turn on columns that use this segment.


   PORTB = ~( ((DD[0] & segMask)?0x01:0)  |
              ((DD[1] & segMask)?0x02:0)  |
              ((DD[2] & segMask)?0x04:0)  |
              ((DD[3] & segMask)?0x08:0)  |
              ((DD[4] & segMask)?0x10:0)  |
              ((DD[5] & segMask)?0x20:0)  );
        
    PORTC = ~( ((DD[6] & segMask)?0x01:0)  |
               ((DD[7] & segMask)?0x02:0)  |
               ((DD[8] & segMask)?0x04:0)  |
               ((DD[9] & segMask)?0x08:0)  |
               ((DD[10] & segMask)?0x10:0)  |
               ((DD[11] & segMask)?0x20:0)  );
    
    segMask = (segMask==0x40)?0x01:(segMask<<1); // next segment
    delay(1); // allow viewing.    
    
    
    
    // do scrolling stuffs
    i--;
    if (i == 0) {
      i = 1000;
      offset++;
      if ((offset%msglen)==0) offset = 0;            
      DD[0]  = CG2[message[(offset+0)%msglen]-'0'];      
      DD[1]  = CG2[message[(offset+1)%msglen]-'0'] ;      
      DD[2]  = CG2[message[(offset+2)%msglen]-'0'] ;      
      DD[3]  = CG2[message[(offset+3)%msglen]-'0'] ;      
      DD[4]  = CG2[message[(offset+4)%msglen]-'0'] ;       
      DD[5]  = CG2[message[(offset+5)%msglen]-'0'] ;       
      DD[6]  = CG2[message[(offset+6)%msglen]-'0'] ;       
      DD[7]  = CG2[message[(offset+7)%msglen]-'0'] ;       
      DD[8]  = CG2[message[(offset+8)%msglen]-'0'] ;       
      DD[9]  = CG2[message[(offset+9)%msglen]-'0'] ;       
      DD[10] = CG2[message[(offset+10)%msglen]-'0'];       
      DD[11] = CG2[message[(offset+11)%msglen]-'0'];  
    }
  

}

void clear(void){
  PORTB = 0xFF;
  PORTC = 0xFF;  
}

